hdu-5652 India and China Origins(二分+bfs判断连通)

题目链接:

India and China Origins

Time Limit: 2000/2000 MS (Java/Others)    

Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 685    Accepted Submission(s): 230


Problem Description
A long time ago there are no himalayas between India and China, the both cultures are frequently exchanged and are kept in sync at that time, but eventually himalayas rise up. With that at first the communation started to reduce and eventually died.



Let's assume from my crude drawing that the only way to reaching from India to China or viceversa is through that grid, blue portion is the ocean and people haven't yet invented the ship. and the yellow portion is desert and has ghosts roaming around so people can't travel that way. and the black portions are the location which have mountains and white portions are plateau which are suitable for travelling. moutains are very big to get to the top, height of these mountains is infinite. So if there is mountain between two white portions you can't travel by climbing the mountain.
And at each step people can go to 4 adjacent positions.

Our archeologists have taken sample of each mountain and estimated at which point they rise up at that place. So given the times at which each mountains rised up you have to tell at which time the communication between India and China got completely cut off.
 

 

Input
There are multi test cases. the first line is a sinle integer T which represents the number of test cases.

For each test case, the first line contains two space seperated integers N,M. next N lines consists of strings composed of 0,1 characters. 1 denoting that there's already a mountain at that place, 0 denoting the plateau. on N+2 line there will be an integer Q denoting the number of mountains that rised up in the order of times. Next Q lines contain 2 space seperated integers X,Y denoting that at ith year a mountain rised up at location X,Y.

T10

1N500

1M500

1QNM

0X<N

0Y<M
 

 

Output
Single line at which year the communication got cut off.

print -1 if these two countries still connected in the end.

Hint:



From the picture above, we can see that China and India have no communication since 4th year.
 

 

Sample Input
1
4 6
011010
000010
100001
001000
7
0 3
1 5
1 3
0 0
1 2
2 4
2 1
 

 

Sample Output
4
 
 
 
题意:    
 
给你一些0和1组成的字符串,表示i行j列的状态,0表示平原,1表示山峰,然后再给你q个数对表示在第i年位置l,r处要变成山峰;问最早在第几年印度和中国之间不再连通了;
 
 
思路:
 
比赛的时候直接bfs判断连通性,最后tle了,后来看别人博客说要二分,或者用并查集,想了一会还是想不好并查集怎么处理,就写了个二分+bfs;啊啊,写了几个二分之后发现现在写二分好好玩啊,一开始入ACM坑的时候写的二分都忒傻逼的那种,现在终于变成熟了,啊哈哈哈哈;我骄傲!不过现在我仍然好弱好弱,还是要不断加油才行;
 
 
 
AC代码:
#include <iostream>
#include <cstdio>
#include <queue>
#include <cstring>
#include <algorithm>
using namespace std;
int n,m,q,dir[4][2]={0,1,0,-1,1,0,-1,0},vis[502][502],l[250010],r[250010];
char str[501][505];
struct node
{
    int x,y;
};
node a;
queue<node>qu;
int check(int num)
{
    while(!qu.empty())qu.pop();
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            if(str[i][j]=='1')vis[i][j]=1;
            else vis[i][j]=0;
        }
    }
    for(int i=1;i<=num;i++)
    {
        vis[l[i]][r[i]]=1;
    }
    for(int k=0;k<m;k++)
    {
        if(!vis[0][k])
        {
            a.x=0;
            a.y=k;
            qu.push(a);
        }
    while(!qu.empty())
    {
       int topx=qu.front().x,topy=qu.front().y;
       qu.pop();
       if(topx==n-1)return 1;
       for(int i=0;i<4;i++)
       {
           int fx=topx+dir[i][0],fy=topy+dir[i][1];
           if(fx>=0&&fx<n&&fy>=0&&fy<m)
           {
               if(!vis[fx][fy])
               {
                   if(fx==n-1)return 1;
                   a.x=fx;
                   a.y=fy;
                   qu.push(a);
                   vis[fx][fy]=1;
               }
           }
       }
    }
    }
    return 0;
}
int bis()
{
    int L=0,R=q,mid;
    while(L<=R)
    {
        mid=(L+R)>>1;
        if(check(mid))L=mid+1;
        else R=mid-1;
    }
    if(L>q)return -1;
    return L;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        for(int i=0;i<n;i++)
        {
            scanf("%s",str[i]);
        }
        scanf("%d",&q);
        for(int i=1;i<=q;i++)
        {
            scanf("%d%d",&l[i],&r[i]);
        }
        printf("%d\n",bis());
    }
    return 0;
}

 

posted @ 2016-03-27 21:29  LittlePointer  阅读(364)  评论(0编辑  收藏  举报